import { OrderedSet } from "immutable";
import { Type, NamedType, ClassType, UnionType } from "./Type";
import { Namespace, Name, Namer, DependencyName } from "./Naming";
import { Renderer, BlankLineLocations } from "./Renderer";
export declare abstract class ConvenienceRenderer extends Renderer {
    protected globalNamespace: Namespace;
    private _topLevelNames;
    private _classAndUnionNames;
    private _propertyNames;
    private _namedTypes;
    private _namedClasses;
    private _namedUnions;
    protected readonly forbiddenNamesForGlobalNamespace: string[];
    protected forbiddenForProperties(c: ClassType, classNamed: Name): {
        names: Name[];
        namespaces: Namespace[];
    };
    protected topLevelDependencyNames(topLevelName: Name): DependencyName[];
    protected abstract topLevelNameStyle(rawName: string): string;
    protected readonly abstract namedTypeNamer: Namer;
    protected readonly abstract propertyNamer: Namer;
    protected abstract namedTypeToNameForTopLevel(type: Type): NamedType | null;
    protected abstract emitSourceStructure(): void;
    protected unionNeedsName(u: UnionType): boolean;
    protected setUpNaming(): Namespace[];
    private nameForTopLevel;
    private addClassOrUnionNamed;
    private addPropertyNameds;
    private childrenOfType;
    protected readonly namedUnions: OrderedSet<UnionType>;
    protected readonly haveUnions: boolean;
    protected unionFieldName: (t: Type) => string;
    protected nameForNamedType: (t: NamedType) => Name;
    protected forEachTopLevel: (blankLocations: BlankLineLocations, f: (t: Type, name: Name) => void) => void;
    protected forEachProperty: (c: ClassType, blankLocations: BlankLineLocations, f: (name: Name, jsonName: string, t: Type) => void) => void;
    protected callForClass: (c: ClassType, f: (c: ClassType, className: Name) => void) => void;
    protected forEachClass: (blankLocations: BlankLineLocations, f: (c: ClassType, className: Name) => void) => void;
    protected callForUnion: (u: UnionType, f: (u: UnionType, unionName: Name) => void) => void;
    protected forEachUnion: (blankLocations: BlankLineLocations, f: (u: UnionType, unionName: Name) => void) => void;
    protected forEachUniqueUnion: (blankLocations: BlankLineLocations, unionMembers: (u: UnionType) => OrderedSet<Type>, f: (members: OrderedSet<Type>) => void) => void;
    protected forEachNamedType: (blankLocations: BlankLineLocations, leavesFirst: boolean, classFunc: (c: ClassType, className: Name) => void, unionFunc: (u: UnionType, unionName: Name) => void) => void;
    protected emitSource(): void;
}
