"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var TargetLanguage_1 = require("../TargetLanguage");
var Renderers = require("../Language.Renderers")
var CSharp_1 = require("./CSharp");
var Golang_1 = require("./Golang");
var SimpleTypes_1 = require("./SimpleTypes");
var typeScriptTargetLanguages = [
    new CSharp_1.default(),
    new Golang_1.default(),
    new SimpleTypes_1.default()
];
var pureScriptTargetLanguages = Renderers.all.map(function (r) { return new TargetLanguage_1.PureScriptTargetLanguage(r); });
exports.all = typeScriptTargetLanguages.concat(pureScriptTargetLanguages);
function languageNamed(name) {
    return lodash_1.find(exports.all, function (l) { return lodash_1.includes(l.names, name) || l.displayName === name; });
}
exports.languageNamed = languageNamed;
